//+------------------------------------------------------------------+
//|                                                      C_Mouse.mqh |
//|                                                      Daniel Jose |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Daniel Jose"
//+------------------------------------------------------------------+
#define def_MouseName "MOUSE_H"
//+------------------------------------------------------------------+
#define def_BtnLeftClick(A)	((A & 0x01) == 0x01)
#define def_SHIFT_Press(A)		((A & 0x04) == 0x04)
#define def_CTRL_Press(A)		((A & 0x08) == 0x08)
//+------------------------------------------------------------------+
class C_Mouse
{
	private	:
		struct st00
		{
			long 		Id;
			color		Cor;
			double	PointPerTick,
						Price;
			uint		BtnStatus;
		}m_Infos;
//+------------------------------------------------------------------+
		void CreateLineH(void)
			{
 				ObjectCreate(m_Infos.Id, def_MouseName, OBJ_HLINE, 0, 0, 0);
 				ObjectSetString(m_Infos.Id, def_MouseName, OBJPROP_TOOLTIP, "\n");
 				ObjectSetInteger(m_Infos.Id, def_MouseName, OBJPROP_BACK, false);
 				ObjectSetInteger(m_Infos.Id, def_MouseName, OBJPROP_COLOR, m_Infos.Cor);
			}
//+------------------------------------------------------------------+
inline double AdjustPrice(const double value)
			{
				return MathRound(value / m_Infos.PointPerTick) * m_Infos.PointPerTick;
			}
//+------------------------------------------------------------------+
	public	:
//+------------------------------------------------------------------+
		C_Mouse(const color cor)
			{
				m_Infos.Id = ChartID();
				m_Infos.Cor = cor;
				m_Infos.PointPerTick = SymbolInfoDouble(_Symbol, SYMBOL_TRADE_TICK_SIZE);
				ChartSetInteger(m_Infos.Id, CHART_EVENT_MOUSE_MOVE, true);
				ChartSetInteger(m_Infos.Id, CHART_EVENT_OBJECT_DELETE, true);
				CreateLineH();
			}
//+------------------------------------------------------------------+	
		~C_Mouse()
			{
				ChartSetInteger(m_Infos.Id, CHART_EVENT_OBJECT_DELETE, false);
				ObjectDelete(m_Infos.Id, def_MouseName);
			}
//+------------------------------------------------------------------+	
const void GetStatus(double &Price, uint &BtnStatus) const
			{
				Price = m_Infos.Price;
				BtnStatus = m_Infos.BtnStatus;
			}
//+------------------------------------------------------------------+	
		void DispatchMessage(const int id, const long &lparam, const double &dparam, const string &sparam)
			{
				int w;
				datetime dt;
				
				switch (id)
					{
						case CHARTEVENT_OBJECT_DELETE:
							if (sparam == def_MouseName) CreateLineH();
							break;
						case CHARTEVENT_MOUSE_MOVE:
							ChartXYToTimePrice(m_Infos.Id, (int)lparam, (int)dparam, w, dt, m_Infos.Price);
							ObjectMove(m_Infos.Id, def_MouseName, 0, 0, m_Infos.Price = AdjustPrice(m_Infos.Price));
							m_Infos.BtnStatus = (uint)sparam;
							ChartRedraw();
							break;
					}
			}
//+------------------------------------------------------------------+	
};
//+------------------------------------------------------------------+
#undef def_MouseName
//+------------------------------------------------------------------+
